/*
 *      p7-1.c
 *      Beispielprogramm 1, Abschnitt 7
 */

static int day_tab[2][13] = {
  { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
  { 0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }
};

/* Tag im Jahr aus Monat und Tag bestimmen */
int day_of_year(int year, int month, int day)
{
  int i, leap;
  
  leap = year % 4 == 0 && year % 100 != 0 || year % 400 == 0;
  for (i = 1; i < month; i++)
    day += day_tab[leap][i];
  return (day);

} /* day_of_year() */

/* Monat und Tag aus Tag im Jahr */
void month_day(int year, int yearday, int *pmonth, int *pday)
{
  int i, leap;
  
  leap = year % 4 == 0 && year % 100 != 0 || year % 400 == 0;
  for (i = 1; yearday > day_tab[leap][i]; i++)
    yearday -= day_tab[leap][i];
  *pmonth = i;
  *pday = yearday;

} /* month_day() */
