/*
 *      p9-1.c 
 *      Beispielprogramm 1, Abschnitt 9
 *      Realisierung von fgets und fputs 
 */

#include <stdio.h>

/* hoechstens n Zeichen ueber iop einlesen */
char *fgets(char *s, int n, register FILE *iop)
{
  register int c;
  register char *cs;
  
  cs = s;
  while (--n > 0 && (c = getc(iop)) != EOF)
    if ((*cs++ = c) == '\n')
      break;
  *cs = '\0';
  return((c == EOF && cs == s) ? NULL : s);
  
} /* fgets() */

/* Zeichenkette s ueber iop ausgeben */
void fputs(register char *s, register FILE *iop)
{
  register int c;
  
  while (c = *s++)
    putc(c, iop);

} /* fputs() */
